local tabardlink = nil
local tabardlinkout = nil
local tabardchat = true
local version = GetAddOnMetadata("TabardChampion", "Version") 

local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff78TabardChampion:|r "..msg)
end

local function settabard()
	return GetInventoryItemLink("player", GetInventorySlotInfo("TabardSlot"))
end

-- equip taht ugly thing -.-
local function equiptabard(link)
	if link then
		EquipItemByName(link, GetInventorySlotInfo("TabardSlot"))
		if tabardchat then
			print("equipped "..link.." you are ugly now -.-")
		end
	end
end

-- retrun the id of an bag with a free slot
-- 0 if free slot InBackpack
-- nil if all bags are full
local function getFreeBag()
	local freeid, typeid
	for bagid = NUM_BAG_SLOTS, 0, -1 do
		freeid, typeid = GetContainerNumFreeSlots(bagid)
		if  freeid > 0 and typeid == 0 then
			return bagid
		end
	end
	return nil
end

-- and off with it, yeah!
local function removetabard()
	if tabardlink then
		ClearCursor()
		PickupInventoryItem(GetInventorySlotInfo("TabardSlot"))
		
		local freeid = getFreeBag()
		if freeid then
			if freeid == 0 then
				PutItemInBackpack()
			else
				PutItemInBag(freeid+19)
			end
			--unequip any tabard
			local currentequipped = GetInventoryItemLink("player", GetInventorySlotInfo("TabardSlot"))
			if currentequipped and tabardchat then
				print("relieved you of "..currentequipped.." yeah!")
			end
		else
			print("can't remove tabard, inventory is full *cry*")
			ClearCursor()
		end
	end
end

local function enteringWorld()
	if event == "PLAYER_ENTERING_WORLD" then
		if not UnitIsDeadOrGhost("Player") then 
			local inini, initype = IsInInstance() 
			if initype == "party" then
				equiptabard(tabardlink)
			else
				if tabardlinkout then
					equiptabard(tabardlinkout)
				else
					removetabard()
				end
			end
		end
	else 
		tabardlink = TabardChampion_Tabard
		tabardlinkout = TabardChampion_TabardOut
		tabardchat = TabardChampion_Chat
	end
end

local function info()
	print("Settings: ")
	if tabardlink then
		DEFAULT_CHAT_FRAME:AddMessage("Instance tabard: "..tabardlink)
	else
		DEFAULT_CHAT_FRAME:AddMessage("Instance tabard: non")
	end
	if tabardlinkout then
		DEFAULT_CHAT_FRAME:AddMessage("Normal tabard: "..tabardlinkout)
	else
		DEFAULT_CHAT_FRAME:AddMessage("Normal tabard: non")
	end
	if tabardchat then
		DEFAULT_CHAT_FRAME:AddMessage("chat messages on.")
	else
		DEFAULT_CHAT_FRAME:AddMessage("chat message off.")
	end
	DEFAULT_CHAT_FRAME:AddMessage("------------------------------------")
end

local function slashHandler(msg)
	if msg == "in" then
		TabardChampion_Tabard = settabard()
		tabardlink = TabardChampion_Tabard
		info()
	elseif msg == "out" then
		TabardChampion_TabardOut = settabard()
		tabardlinkout = TabardChampion_TabardOut
		info()
	elseif msg == "info" then
		info()
	elseif msg == "clear" then
		tabardlink = nil
		tabardlinkout = nil
		TabardChampion_Tabard = nil
		TabardChampion_TabardOut = nil
	elseif msg == "chat" then
		tabardchat = not tabardchat
		TabardChampion_Chat = tabardchat
		info()
	else
		-- no comannd option
		DEFAULT_CHAT_FRAME:AddMessage("---------------------------------")
		print("Version "..version)
		DEFAULT_CHAT_FRAME:AddMessage("Usage: /iht {in | out | clear}")
		DEFAULT_CHAT_FRAME:AddMessage("- in: Set instance tabard.")
		DEFAULT_CHAT_FRAME:AddMessage("- out: Set normal tabard.")
		DEFAULT_CHAT_FRAME:AddMessage("- info: Show settings.")
		DEFAULT_CHAT_FRAME:AddMessage("- clear: Disable Tabard Champion.") 
		DEFAULT_CHAT_FRAME:AddMessage("- chat: Toggle chat messages.")
		DEFAULT_CHAT_FRAME:AddMessage("---------------------------------")
	end
end

SlashCmdList["TabardChampion"] = slashHandler;
SLASH_TabardChampion1 = "/tabardchampion";
SLASH_TabardChampion2 = "/tc";

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("VARIABLES_LOADED")
frame:SetScript("OnEvent", enteringWorld)